#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"

// LED_/p}N
#define ON	0x00
#define OFF 0xFF
// LED_p^[pϐ
char StateA;
char StateB;

// 荞ݏiJE^Aj
void Timer0AIntHandler(void) {
	// ^C}Zbg
	TimerIntClear(WTIMER0_BASE, TIMER_TIMA_TIMEOUT);
	// rbg]
	StateA = ~StateA;
}

// 荞ݏiJE^Bj
void Timer0BIntHandler(void) {
	// ^C}Zbg
	TimerIntClear(WTIMER0_BASE, TIMER_TIMB_TIMEOUT);
	// rbg]
	StateB = ~StateB;
}

// LED̓_łƏJԂ
void main(void) {
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : LEDpɃ|[gDgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	// : Ch^C}W[0gp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_WTIMER0);

	// PD0o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);

	// ^C}̐ݒ
	// : Ch^C}W[032bit̎JE^A, B ƂĎgp
	TimerConfigure(WTIMER0_BASE, TIMER_CFG_SPLIT_PAIR | TIMER_CFG_A_PERIODIC | TIMER_CFG_B_PERIODIC);
	// : ^C}̊荞݂Ԋuݒ
	TimerLoadSet(WTIMER0_BASE, TIMER_A, SysCtlClockGet());
	TimerLoadSet(WTIMER0_BASE, TIMER_B, SysCtlClockGet() / 10);
	// : 荞ݎɌĂяoi֐jw
	TimerIntRegister(WTIMER0_BASE, TIMER_A, Timer0AIntHandler);
	TimerIntRegister(WTIMER0_BASE, TIMER_B, Timer0BIntHandler);
	// : 荞݂
	IntEnable(INT_WTIMER0A);
	IntEnable(INT_WTIMER0B);
	// : ^CAEgŊ荞݂
	TimerIntEnable(WTIMER0_BASE, TIMER_TIMA_TIMEOUT);
	TimerIntEnable(WTIMER0_BASE, TIMER_TIMB_TIMEOUT);
	// : ^C}L
	TimerEnable(WTIMER0_BASE, TIMER_A);
	TimerEnable(WTIMER0_BASE, TIMER_B);

	// LEDOFFɂ
	StateA = OFF;
	StateB = OFF;

	while (1) {
		// LEDON/OFFɂ
		GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, StateA | StateB);
	}
}
