#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"
#include "driverlib/adc.h"

// LED_/p}N
#define ON	0x00
#define OFF 0xFF
// LED_p^[pϐ
char State;

// A/Dϊli[p
uint32_t data;

// 荞ݏ
void Timer0IntHandler(void) {
	// ύXpϐ
	static long period;
	// ^C}Zbg
	TimerIntClear(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
	// rbg]
	State = ~State;
	// LEDON/OFFɂ
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);
	// A/Dl1/400ɂ
	period = data / 400;
	if (period < 1) period = 1;
	// 0.1`1bɕύX
	TimerLoadSet(TIMER0_BASE, TIMER_A, SysCtlClockGet() / period);
}

// {[LED̓_ŎύX
void main(void) {
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : LEDpIO|[gDAAiO͗pɃ|[gEgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
	// : A/DϊW[0gp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
	// : ^C}W[0gp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);

	// PD0o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);

	// A/Dϊ̐ݒ
	// : PE3(AIN0)ADCɐݒ
	GPIOPinTypeADC(GPIO_PORTE_BASE, GPIO_PIN_3);
	// : gpADCV[PX̎w
	ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
	// : ADCV[PX̐ݒ
	ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH0 | ADC_CTL_IE | ADC_CTL_END);
	// : ADCV[PXLɂ
	ADCSequenceEnable(ADC0_BASE, 3);

	// ^C}ъ荞݂̐ݒ
	// : ^C}0̑S32bitJE^ƂĎgp
	TimerConfigure(TIMER0_BASE, TIMER_CFG_PERIODIC);
	// : ^C}0̊荞݂Ԋuݒ
	TimerLoadSet(TIMER0_BASE, TIMER_A, SysCtlClockGet());
	// : 荞ݎɌĂяoi֐jw
	TimerIntRegister(TIMER0_BASE, TIMER_A, Timer0IntHandler);
	// : 荞݂
	IntEnable(INT_TIMER0A);
	// : ^CAEgŊ荞݂
	TimerIntEnable(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
	// : ^C}荞݂
	TimerEnable(TIMER0_BASE, TIMER_A);

	// LEDOFFɂ
	State = OFF;
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);

	while (1) {
		// A/DϊJn
		ADCProcessorTrigger(ADC0_BASE, 3);
		// A/Dϊl̎擾
		ADCSequenceDataGet(ADC0_BASE, 3, &data);
	}
}
