#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"
#include "driverlib/adc.h"
#include "driverlib/pin_map.h"
#include "driverlib/pwm.h"

// PWMɂLED̃tJ[\
void main(void) {
	// A/Dϊli[p
	uint32_t data;
	// LEDp
	unsigned long led[3];
	// RGBp
	int rgb;
	// ݒpϐ
	unsigned long ulPeriod;
	// ҂ԗp
	volatile unsigned long Loop;
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : |[gFiLED pjA|[gBiXCb`pjA|[gEiAiO͗pj𗘗p
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
	// : A/DϊW[0𗘗p
	SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
	// : PWMW[1𗘗p
	SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM1);

	// PB2`PB5̓sɐݒ
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_2);
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_3);
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_4);
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_5);

	// ADC̐ݒ
	// PE3(AIN0)ADCɐݒ
	GPIOPinTypeADC(GPIO_PORTE_BASE, GPIO_PIN_3);
	// : gpADC̎w
	ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
	// : ADCV[PT̐ݒ
	ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH0 | ADC_CTL_IE | ADC_CTL_END);
	// : ADCV[PTLɂ
	ADCSequenceEnable(ADC0_BASE, 3);

	// PWM̐ݒ
	// : PF1(M1PWM5), PF2(M1PWM6), PF3(M1PWM7)PWMɐݒ
	GPIOPinTypePWM(GPIO_PORTF_BASE, GPIO_PIN_1);
	GPIOPinTypePWM(GPIO_PORTF_BASE, GPIO_PIN_2);
	GPIOPinTypePWM(GPIO_PORTF_BASE, GPIO_PIN_3);
	// : PF1M1PWM5, PF2M1PWM6, PF3M1PWM7ɐݒ
	GPIOPinConfigure(GPIO_PF1_M1PWM5);
	GPIOPinConfigure(GPIO_PF2_M1PWM6);
	GPIOPinConfigure(GPIO_PF3_M1PWM7);
	// : PWM̎w@F 1ms
	ulPeriod = SysCtlClockGet() / 1000;
	// : PWMWFl[^̐ݒ
	PWMGenConfigure(PWM1_BASE, PWM_GEN_2, PWM_GEN_MODE_UP_DOWN | PWM_GEN_MODE_NO_SYNC);
	PWMGenConfigure(PWM1_BASE, PWM_GEN_3, PWM_GEN_MODE_UP_DOWN | PWM_GEN_MODE_NO_SYNC);
	// : PWMWFl[^̎ݒ
	PWMGenPeriodSet(PWM1_BASE, PWM_GEN_2, ulPeriod);
	PWMGenPeriodSet(PWM1_BASE, PWM_GEN_3, ulPeriod);
	// : PWM̃f[eB̎w
	PWMPulseWidthSet(PWM1_BASE, PWM_OUT_5, ulPeriod * 9 / 10);
	PWMPulseWidthSet(PWM1_BASE, PWM_OUT_6, ulPeriod * 9 / 10);
	PWMPulseWidthSet(PWM1_BASE, PWM_OUT_7, ulPeriod * 9 / 10);
	// : PWM1̏o͂
	PWMOutputState(PWM1_BASE, PWM_OUT_5_BIT, true);
	PWMOutputState(PWM1_BASE, PWM_OUT_6_BIT, true);
	PWMOutputState(PWM1_BASE, PWM_OUT_7_BIT, true);
	// : PWMJn
	PWMGenEnable(PWM1_BASE, PWM_GEN_2);
	PWMGenEnable(PWM1_BASE, PWM_GEN_3);

	// LEDݒ
	led[0] = 0;
	led[1] = 0;
	led[2] = 0;
	rgb = 3;

	while (1) {
		// PSW1ŐԂAPSW2ŗ΂APSW3ŐωBPSW4Ń{[B
		if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_2) == 0) rgb = 0;
		if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_3) == 0) rgb = 1;
		if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_4) == 0) rgb = 2;
		if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_5) == 0) rgb = 3;

		// A/DϊJn
		ADCProcessorTrigger(ADC0_BASE, 3);
		// A/Dϊl̎擾
		ADCSequenceDataGet(ADC0_BASE, 3, &data);
		// A/Dϊ̒lɉăf[eBύXi40ȉ̓f[eB0%Ƃj
		if (data < 40) data = 40;
		if (rgb >= 0 && rgb <= 2) led[rgb] = ulPeriod * (data - 40) / (4096 - 40);

		// LEDlݒ
		PWMPulseWidthSet(PWM1_BASE, PWM_OUT_5, led[0]);
		PWMPulseWidthSet(PWM1_BASE, PWM_OUT_6, led[2]);
		PWMPulseWidthSet(PWM1_BASE, PWM_OUT_7, led[1]);
	}
}
