#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/systick.h"
#include "driverlib/interrupt.h"
#include "driverlib/adc.h"
#include "driverlib/pin_map.h"
#include "driverlib/pwm.h"

// ҂ԗp
volatile long g_cnt = 0;

// 荞ݏ
void SysTickHandler(void) {
	// g_cntfNgi-1j
	g_cnt--;
}

// ԑ҂
void DelayMs(unsigned long ms) {
	// JEgiԁjZbg
	g_cnt = ms;
	// SysTickLiJEgJnj
	SysTickEnable();
	// g_cnt0 菬Ȃ܂Ń[vi荞݃[`g_cntfNgj
	while (g_cnt > 0)
		;
	// SysTick~iJEg~j
	SysTickDisable();
}

// RSM̐ݒ
void lcd_RS(unsigned char value) {
	if (value != 0) value = 0xFF;
	GPIOPinWrite(GPIO_PORTE_BASE, GPIO_PIN_1, value);
}

// ݒ肵R}hsiE[qLHL Ɛ؂ւj
void lcd_command() {
	GPIOPinWrite(GPIO_PORTE_BASE, GPIO_PIN_0, 0xFF);
	GPIOPinWrite(GPIO_PORTE_BASE, GPIO_PIN_0, 0x00);
}

// f[^]i8rbg[hj
void lcd_transmit8(unsigned char data) {
	// 4rbgݒi4rbg̒[q̓I[vj
	data = data >> 2;
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, data);
	lcd_command();
}

// f[^]i4rbg[hj
void lcd_transmit4(unsigned char data) {
	unsigned char temp;
	// 4rbgݒ
	temp = data >> 2;
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, temp);
	lcd_command();
	// 4rbgݒ
	temp = data << 2;
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, temp);
	lcd_command();
}

// LCD̏
void lcd_init(void) {
	// RSMLowɐݒ
	lcd_RS(0);
	// 15 ~b҂
	DelayMs(15);
	// 8rbg[hɐݒif[^rbg0011 **** = 0x30 𑗂j
	lcd_transmit8(0x30);
	// 5 ~b҂
	DelayMs(5);
	// ēx8rbg[hɐݒif[^rbg0011 **** = 0x30 𑗂j
	lcd_transmit8(0x30);
	// 1 ~b҂
	DelayMs(1);
	// āXx8rbg[hɐݒif[^rbg0011 **** = 0x30 𑗂j
	lcd_transmit8(0x30);
	// 5 ~b҂
	DelayMs(5);
	// 4rbg[hɐݒif[^rbg0010 **** = 0x20 𑗂j
	lcd_transmit8(0x20);
	// 1 ~b҂
	DelayMs(1);
	// ݒi4rbgEoXA2s\Bf[^rbg0010 1000 = 0x28 𑗂j
	lcd_transmit4(0x28);
	// 1 ~b҂
	DelayMs(1);

	// \[h̐ݒ
	// i\ONAJ[\ȂAuNȂBf[^rbg0000 1100 = 0x0C 𑗂j
	lcd_transmit4(0x0C);
	// 1 ~b҂
	DelayMs(1);
	// ̓[h̐ݒiAhX+1AVtgȂBf[^rbg0000 0110 = 0x06 𑗂j
	lcd_transmit4(0x06);
	// 1 ~b҂
	DelayMs(1);
}

// LCD̕\NA
void lcd_clear(void) {
	// RSMLowɐݒ
	lcd_RS(0);
	// NA
	lcd_transmit4(0x01);
	// 1 ~b҂
	DelayMs(1);
}

// LCDɕ\
void lcd_disp(char* s) {
	// RSMHighɐݒ
	lcd_RS(1);
	// f[^o
	while (*s) {
		// 1oCgf[^𑗐M
		lcd_transmit4(*s++);
		// 1 ~b҂
		DelayMs(1);
	}
}

// 1sڂ2sڂɉs
void lcd_NewLine(void) {
	// RSMLowɐݒ
	lcd_RS(0);
	// J[\2sڐ擪Ɉړi0x80 + 0x40 = 0xC0j
	lcd_transmit4(0xC0);
	// 1 ~b҂
	DelayMs(1);
}

// LCD̃J[\z[|WV
void lcd_Home(void) {
	// RSMLowɐݒ
	lcd_RS(0);
	// J[\z[|WVɖ߂
	lcd_transmit4(0x02);
	// 1 ~b҂
	DelayMs(1);
}

// {[͂ɂDC[^x{LCDA/Dlƃf[eB\
void main(void) {
	// A/Dϊli[p
	uint32_t data;
	// ݒpϐ
	unsigned long ulPeriod;
	// ҂ԗp
	volatile unsigned long Loop;
	// lϊpi̍Ōオ\0ɂȂ悤ɂj
	char temp[2] = " ";
	// LCDւ̏o͕
	char text_1[17];
	char text_2[17];
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : |[gAA|[gEiLCD pj
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
	// : A/DϊW[0
	SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
	// : PWMW[0
	SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM0);

	// PA2~PA5, PE0, PE1 o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_2);
	GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_3);
	GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_4);
	GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_5);
	GPIOPinTypeGPIOOutput(GPIO_PORTE_BASE, GPIO_PIN_0);
	GPIOPinTypeGPIOOutput(GPIO_PORTE_BASE, GPIO_PIN_1);

	// ADC̐ݒ
	// : PE3(AIN0)ADCɐݒ
	GPIOPinTypeADC(GPIO_PORTE_BASE, GPIO_PIN_3);
	// : gpADCV[PT̎w
	ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
	// : ADCV[PT̐ݒ
	ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH0 | ADC_CTL_IE | ADC_CTL_END);
	// : ADCV[PTLɂ
	ADCSequenceEnable(ADC0_BASE, 3);

	// PWM̐ݒ
	// : PWM@\Ŏg|[g̎w
	GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_4);
	GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_5);
	// : PE4M0PWM4 ɁAPE5M0PWM5ɐݒ
	GPIOPinConfigure(GPIO_PE4_M0PWM4);
	GPIOPinConfigure(GPIO_PE5_M0PWM5);
	// : PWM̎w@F 1ms
	ulPeriod = SysCtlClockGet() / 1000;
	// : PWMWFl[^̐ݒ
	PWMGenConfigure(PWM0_BASE, PWM_GEN_2, PWM_GEN_MODE_UP_DOWN | PWM_GEN_MODE_NO_SYNC);
	// : PWMWFl[^̎ݒ
	PWMGenPeriodSet(PWM0_BASE, PWM_GEN_2, ulPeriod);
	// : PWM̃f[eB̎w
	PWMPulseWidthSet(PWM0_BASE, PWM_OUT_4, ulPeriod * 9 / 10);
	PWMPulseWidthSet(PWM0_BASE, PWM_OUT_5, ulPeriod * 9 / 10);
	// : M0PWM4̏o͂, M0PWM5̏o͂s
	PWMOutputState(PWM0_BASE, PWM_OUT_4_BIT, true);
	PWMOutputState(PWM0_BASE, PWM_OUT_5_BIT, false);
	// : PWMJn
	PWMGenEnable(PWM0_BASE, PWM_GEN_2);

	// SysTick̊荞݂Ԋuݒ
	SysTickPeriodSet(SysCtlClockGet() / 1000);
	// 荞ݎɌĂяoi֐jw
	SysTickIntRegister(SysTickHandler);

	// LCD
	lcd_init();
	// LCD\eNA
	lcd_clear();

	while (1) {
		// \̗p
		strcpy(text_1, "A/D ");
		strcpy(text_2, "Duty ");
		// A/DϊJn
		ADCProcessorTrigger(ADC0_BASE, 3);
		// A/Dϊl̎擾
		ADCSequenceDataGet(ADC0_BASE, 3, &data);
		// A/Dϊ̒lɉăf[eBύX
		PWMPulseWidthSet(PWM0_BASE, PWM_OUT_4, ulPeriod * data / 4096);
		// 1A/Dl̐ʂǉ
		temp[0] = 0x30 + (data / 1000);
		strcat(text_1, temp);
		// PA/Dl̕Sʂǉ
		temp[0] = 0x30 + ((data % 1000) / 100);
		strcat(text_1, temp);
		// PA/Dl̏\ʂǉ
		temp[0] = 0x30 + ((data % 100) / 10);
		strcat(text_1, temp);
		// PA/Dl̈ʂǉ
		temp[0] = 0x30 + (data % 10);
		strcat(text_1, temp);
		// 2Ƀf[eB̕Sʂǉ
		temp[0] = 0x30 + ((data * 100 / 4096) / 100);
		strcat(text_2, temp);
		// 2Ƀf[eB̏\ʂǉ
		temp[0] = 0x30 + (((data * 100 / 4096) % 100) / 10);
		strcat(text_2, temp);
		// 2Ƀf[eB̈ʂǉ
		temp[0] = 0x30 + ((data * 100 / 4096) % 10);
		strcat(text_2, temp);
		// 2 Ɂu%vǉ
		temp[0] = '%';
		strcat(text_2, temp);
		// LCDɕ1\
		lcd_disp(text_1);
		// s
		lcd_NewLine();
		// LCDɕ2\
		lcd_disp(text_2);
		// J[\z[
		lcd_Home();
	}
}
